Bug 911188 - Review Request: nodejs-should - A test framework agnostic BDD-style assertions for Node.js
Review Request: nodejs-should - A test framework agnostic BDD-style assertion...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tom Hughes
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-02-14 09:38 EST by Jamie Nguyen
Modified: 2013-04-20 16:15 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-04-04 18:43:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
tom: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Difference between Node's eql and should's eql (3.14 KB, text/plain)
2013-02-24 11:13 EST, Jamie Nguyen
no flags Details

  None (edit)
Description Jamie Nguyen 2013-02-14 09:38:40 EST
Spec URL: http://jamielinux.fedorapeople.org/mocha/nodejs-should.spec
SRPM URL: http://jamielinux.fedorapeople.org/mocha/SRPMS/nodejs-should-1.2.1-1.fc18.src.rpm
Fedora Account System Username: jamielinux

Description:
should is an expressive, readable, test framework agnostic, assertion library
for Node.js.

It extends the Object prototype with a single non-enumerable getter that
allows you to express how that object should behave.

should literally extends Node's assert module. For example,
should.equal(str, 'foo') will work, just as assert.equal(str, 'foo') would,
and should.AssertionError is assert.AssertionError, meaning any test framework
supporting this constructor will function properly with should.
Comment 1 Tom Hughes 2013-02-24 10:37:53 EST
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Package contains no bundled libraries.

It seems that lib/eql.js is (a) taken from node and also (b) the
same as what is in the deep-equal npm. The only problem is that it
was deliberately changed so that 4 and "4" are not equal:

https://github.com/visionmedia/should.js/commit/09886401aba56f21a02796599c1c75301113b978

[!]: Latest version is packaged.

1.2.2 has been released.

[!]: Rpmlint is run on all installed packages.

nodejs-should.noarch: W: spelling-error %description -l en_US bevaviour -> behavior


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[!]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[-]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[!]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 20480 bytes in 3 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[-]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (should-1.2.1.tgz)
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: nodejs-should-1.2.1-1.fc19.noarch.rpm
          nodejs-should-1.2.1-1.fc19.src.rpm
nodejs-should.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-should.noarch: W: spelling-error %description -l en_US bevaviour -> behavior
nodejs-should.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-should.noarch: W: spelling-error %description -l en_US getter -> fetter, setter, netter
nodejs-should.noarch: W: spelling-error %description -l en_US str -> st, tr, stir
nodejs-should.noarch: W: spelling-error %description -l en_US AssertionError -> Assertion Error, Assertion-error, Assertions
nodejs-should.noarch: W: only-non-binary-in-usr-lib
nodejs-should.src: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-should.src: W: spelling-error %description -l en_US bevaviour -> behavior
nodejs-should.src: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-should.src: W: spelling-error %description -l en_US getter -> fetter, setter, netter
nodejs-should.src: W: spelling-error %description -l en_US str -> st, tr, stir
nodejs-should.src: W: spelling-error %description -l en_US AssertionError -> Assertion Error, Assertion-error, Assertions
2 packages and 0 specfiles checked; 0 errors, 13 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-should
nodejs-should.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-should.noarch: W: spelling-error %description -l en_US bevaviour -> behavior
nodejs-should.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-should.noarch: W: spelling-error %description -l en_US getter -> fetter, setter, netter
nodejs-should.noarch: W: spelling-error %description -l en_US str -> st, tr, stir
nodejs-should.noarch: W: spelling-error %description -l en_US AssertionError -> Assertion Error, Assertion-error, Assertions
nodejs-should.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 7 warnings.
# echo 'rpmlint-done:'



Requires
--------
nodejs-should-1.2.1-1.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    nodejs(engine) >= 0.2.0



Provides
--------
nodejs-should-1.2.1-1.fc19.noarch.rpm:
    
    nodejs-should = 1.2.1-1.fc19
    npm(should) = 1.2.1



MD5-sum check
-------------
http://registry.npmjs.org/should/-/should-1.2.1.tgz :
  CHECKSUM(SHA256) this package     : de38ea1e1e9b6b51c19cd60b4bf2d56e822411b837d5fa7d299ca3ddeab01ff9
  CHECKSUM(SHA256) upstream package : de38ea1e1e9b6b51c19cd60b4bf2d56e822411b837d5fa7d299ca3ddeab01ff9


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 911188
Comment 2 Jamie Nguyen 2013-02-24 11:13:43 EST
Created attachment 702051 [details]
Difference between Node's eql and should's eql

> [!]: Package contains no bundled libraries.
> 
> It seems that lib/eql.js is (a) taken from node and also (b) the
> same as what is in the deep-equal npm. The only problem is that it
> was deliberately changed so that 4 and "4" are not equal:
> 
> https://github.com/visionmedia/should.js/commit/09886401aba56f21a02796599c1c75301113b978

Hmm. I'm never really sure how to deal with things like this, but to me it seems like a fork. I've attached a diff of the functions involved and the changes are small but not insignificant.


> [!]: Latest version is packaged.
> 
> 1.2.2 has been released.

Thanks, updated.


> [!]: Rpmlint is run on all installed packages.
> 
> nodejs-should.noarch: W: spelling-error %description -l en_US bevaviour -> behavior

Thanks, fixed.


Spec URL: http://jamielinux.fedorapeople.org/mocha/nodejs-should.spec
SRPM URL: http://jamielinux.fedorapeople.org/mocha/SRPMS/nodejs-should-1.2.2-1.fc18.src.rpm
Comment 3 Tom Hughes 2013-02-24 11:31:05 EST
Yes, the deepEqual thing is all a bit of a mess... The history seems to be something like this:

* buffer comparison added to assert._deepEqual in Sep 2010
* lib/eql.js code copied from assert to should in Nov 2010
* lib/eql.js changed to do strict comparison in Sep 2011
* regexp comparison added to assert._deepEqual in Dec 2011
* deep-equal npm created in Feb 2012

Both the buffer comparison and regpext comparison seem to have been removed when deep-equal was created however (or maybe it was copied from an older version of node).

So the end result is that none of the three are now the same...

I'm not sure what the solution is, other than applying for an exception, presumably on this basis:

https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries#Modified_beyond_a_certain_extent
Comment 4 T.C. Hollingsworth 2013-02-24 23:57:13 EST
Many test frameworks "reinvent the wheel" when it comes to the assert module in the standard library because exceptions in Node are slooooowwww, and suck for other reasons as well.  (Google the subject; there are tons of blog posts about it ;-)

I really don't think forking code like this a Big Deal, since it's a critical part of test frameworks.  I would not be the least bit surprised if other programming languages also have several ever so slightly different implementations of this type of stuff.

I would argue that since should also provides access to this functionality in the form of a library, this a clear fork and okay for Fedora.
Comment 5 Jamie Nguyen 2013-03-02 07:27:35 EST
> I would argue that since should also provides access to this
> functionality in the form of a library, this a clear fork and
> okay for Fedora.

It's not really bundling as such, as it's really a forked library. So I don't think opening a ticket in FPC's trac necessary.


https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries#Exceptions

> Are the changes useful to consumers other than the bundling
> application? If so why aren't we proposing that the library
> be released as a fork of the upstream library?

> is the package we're working on that bundles willing to make
> their fork a library that others can link against?
Comment 6 Tom Hughes 2013-03-09 09:59:49 EST
I attempted to seek some clarification on the bundling issues and the best advice seems to be to try applying for an exception:

http://lists.fedoraproject.org/pipermail/packaging/2013-March/008913.html
Comment 7 Jamie Nguyen 2013-03-10 11:38:40 EDT
Exception ticket opened:

https://fedorahosted.org/fpc/ticket/264
Comment 8 Jamie Nguyen 2013-04-03 17:03:43 EDT
Hurray, exception granted!

https://fedorahosted.org/fpc/ticket/264#comment:7
Comment 9 Tom Hughes 2013-04-03 17:23:03 EDT
Looks like that is everything then, so we can finally say package approved.
Comment 10 Jamie Nguyen 2013-04-03 17:26:43 EDT
New Package SCM Request
=======================
Package Name: nodejs-should
Short Description: A test framework agnostic BDD-style assertions for Node.js
Owners: jamielinux
Branches: f18 f19 el6
InitialCC:
Comment 11 Jon Ciesla 2013-04-04 08:44:45 EDT
Git done (by process-git-requests).
Comment 12 Fedora Update System 2013-04-04 18:39:44 EDT
nodejs-should-1.2.2-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/nodejs-should-1.2.2-1.fc19
Comment 13 Fedora Update System 2013-04-04 18:40:20 EDT
nodejs-should-1.2.2-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/nodejs-should-1.2.2-1.fc18
Comment 14 Fedora Update System 2013-04-13 20:25:50 EDT
nodejs-should-1.2.2-1.fc18 has been pushed to the Fedora 18 stable repository.
Comment 15 Fedora Update System 2013-04-20 16:15:22 EDT
nodejs-should-1.2.2-1.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.